#ifndef VARMAP_H
#define VARMAP_H

#include "configmanager.h"

class VarMap
{
public:
	VarMap();
	~VarMap();

	void			Clear();
	void			Load( const IDataStream& Stream );
	void			Save( const IDataStream& Stream );

	bool			GetBool( const STRING_TYPE& Name, bool Default = false );
	int				GetInt( const STRING_TYPE& Name, int Default = 0 );
	float			GetFloat( const STRING_TYPE& Name, float Default = 0.0f );
	const char*		GetString( const STRING_TYPE& Name, const char* Default = NULL );
	HashedString	GetHash( const STRING_TYPE& Name, const HashedString& Default = HashedString::NullString );

	void			SetBool( const STRING_TYPE& Name, bool Value );
	void			SetInt( const STRING_TYPE& Name, int Value );
	void			SetFloat( const STRING_TYPE& Name, float Value );
	void			SetString( const STRING_TYPE& Name, const char* Value );

private:
	ConfigVar&		GetConfigVar( const STRING_TYPE& Name );
	void			SetConfigVar( const STRING_TYPE& Name, const ConfigVar& Var );

	Map< HashedString, ConfigVar > m_Vars;
};

#endif // VARMAP_H
