#ifndef WBACTIONELDPOSTSCORE_H
#define WBACTIONELDPOSTSCORE_H

#include "wbaction.h"
#include "simplestring.h"
#include "wbparamevaluator.h"
#include "varmap.h"

class WBActionEldPostScore : public WBAction
{
public:
	WBActionEldPostScore();
	virtual ~WBActionEldPostScore();

	DEFINE_WBACTION_FACTORY( EldPostScore );

	virtual void	InitializeFromDefinition( const SimpleString& DefinitionName );
	virtual void	Execute();

	void 			PostScore( SimpleString Username );
	
	static void		LoadScore( VarMap& Score );
	static void		SaveScore( VarMap& Score );
private:
	static SimpleString	GetScoreFile();

	WBParamEvaluator	m_ScorePE;
	SimpleString		m_LeaderboardTag;
};

#endif // WBACTIONELDPOSTSCORE_H